<?php
namespace Teknisa\MAN\Controllers;


use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Teknisa\MAN\Services\ZeramentoSaldoService;
use Teknisa\MAN\Services;
use \Setforms2\Shared\ORM\DateTime;
use Teknisa\MAN\Services\EvoluiSaldo;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Services\NovoCodigo;
 

class ZeramentoSaldo  {
    protected $zeramentoSaldoService;
    protected $evoluiSaldo;
    
    public function __construct (ZeramentoSaldoService $zeramentoSaldoService, EvoluiSaldo $evoluiSaldo, NovoCodigo $novoCodigo){
        $this->EvoluiSaldo = $evoluiSaldo;
        $this->zeramentoSaldoService = $zeramentoSaldoService;
        $this->novoCodigo = $novoCodigo;
    }
    
    public function zeramentoSaldo(DTO\Request\Row $request, DTO\Response $response){
        set_time_limit(120);
	    $conditions = $request->getRow();

	    $DTMOVEXTCONS   = $conditions['DTMOVEXTCONS']; 
	    $CDCLIENTE      = $conditions['CDCLIENTE'];
	    $CDTIPOCONS     = $conditions['CDTIPOCONS'];
	    $DTMOVEXTCONS   = $conditions['DTMOVEXTCONS'];
	    $NRORG          = $conditions['NRORG'];
       
        $ADQSALDONEG = $this->zeramentoSaldoService->adqSaldoNeg($NRORG, $CDCLIENTE, $CDTIPOCONS, $DTMOVEXTCONS);
        if(empty($ADQSALDONEG)){
            $response->addMessage(new Message("Não houve nenhum zeramento efetuado.",Message::TYPE_WARNING));
            return $response;
        } else {
            $DTMOVEXTCONS         = str_replace('/', '-', $DTMOVEXTCONS);
            $DTMOVEXTCONS_2_MONTH = str_replace('-', '/', date("d-m-Y", strtotime($DTMOVEXTCONS." - 60 day")));
            $DTMOVEXTCONS         = str_replace('-', '/', $DTMOVEXTCONS);
            foreach ($ADQSALDONEG as $SALDONEG) {
              $conditions = array(
    			'CDCLIENTE'	   => $SALDONEG['CDCLIENTE'],
    			'CDCONSUMIDOR' => $SALDONEG['CDCONSUMIDOR'],
    			'DTMOVEXTCONS' => $DTMOVEXTCONS_2_MONTH,
    			'NRORG'        => $NRORG
    			);
    			$this->EvoluiSaldo->EvoluiSaldoFunction($conditions);
            }
            $ADQSALDONEG = $this->zeramentoSaldoService->adqSaldoNeg($NRORG, $CDCLIENTE, $CDTIPOCONS, $DTMOVEXTCONS);
            foreach ($ADQSALDONEG as $SALDONEG) {
                $date = date('d/m/Y');
                $DTMOVEXTCONS != $date ? 0 : $DTMOVEXTCONS = $SALDONEG['DTMOV'];
                $NRSEQREGCREDVND = $this->novoCodigo->getCodeByTableName('EXTRATOCONSVND', $conditions['NRORG']);
                $conditions = array(
        			'CDCLIENTE'	   => $SALDONEG['CDCLIENTE'],
        			'CDCONSUMIDOR' => $SALDONEG['CDCONSUMIDOR'],
        			'DTMOVEXTCONS' => $DTMOVEXTCONS,
        			'NRORG'        => $NRORG
    			);
                $ADQSEQMOVEXTR =  $this->zeramentoSaldoService->adqSeqMovExtr($NRORG, $SALDONEG['CDCONSUMIDOR'], $SALDONEG['CDCLIENTE'], $SALDONEG['CDFAMILISALD'], $DTMOVEXTCONS);
                $this->zeramentoSaldoService->acmInsMovExtrato($NRORG, $SALDONEG['CDCONSUMIDOR'], $SALDONEG['CDCLIENTE'], $SALDONEG['CDFAMILISALD'], $DTMOVEXTCONS, $ADQSEQMOVEXTR['NRSEQMOVEXT'], $SALDONEG['VRSALDCONEXT'], $NRSEQREGCREDVND);
                $this->EvoluiSaldo->EvoluiSaldoFunction($conditions);
                $response->addMessage(new Message('Zeramento de saldo efetuado com sucesso!'));
           }
        }
    }
}